package com.hz.pm.api.projectlib.service;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.IService;
import com.hz.pm.api.projectlib.model.entity.ProjectPaymentPlan;
import com.ningdatech.basic.util.CollUtils;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author WendyYang
 * @since 2024-02-21
 */
public interface IProjectPaymentPlanService extends IService<ProjectPaymentPlan> {

    default void remove(String projectCode, Integer projectVersion) {
        remove(Wrappers.lambdaQuery(ProjectPaymentPlan.class)
                .eq(ProjectPaymentPlan::getProjectCode, projectCode)
                .eq(ProjectPaymentPlan::getProjectVersion, projectVersion));
    }

    default Map<Long, List<ProjectPaymentPlan>> listByProjectIds(Collection<Long> projectIds) {
        LambdaQueryWrapper<ProjectPaymentPlan> query = Wrappers.lambdaQuery(ProjectPaymentPlan.class)
                .in(ProjectPaymentPlan::getProjectId, projectIds)
                .orderByAsc(ProjectPaymentPlan::getPaymentYear);
        return CollUtils.group(list(query), ProjectPaymentPlan::getProjectId);
    }

    default List<ProjectPaymentPlan> listByProjectId(Long projectId) {
        LambdaQueryWrapper<ProjectPaymentPlan> query = Wrappers.lambdaQuery(ProjectPaymentPlan.class)
                .eq(ProjectPaymentPlan::getProjectId, projectId)
                .orderByAsc(ProjectPaymentPlan::getPaymentYear);
        return list(query);
    }

}
